<?php
/**
 *
 * Copyright notice
 *
 * (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 */

if (\version_compare(\TYPO3\CMS\Core\Utility\VersionNumberUtility::getCurrentTypo3Version(), '9.0.0', '<')) {
	call_user_func(
		function ($extKey, $table) {
			$pagesTable = 'pages';
			$localLangDbPath = 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_db.xlf:';
			$localLangBackendPath = 'LLL:EXT:' . $extKey . '/Resources/Private/Language/locallang_backend.xlf:';

			$GLOBALS['TYPO3_CONF_VARS']['FE']['pageOverlayFields'] .= ',tx_sgnews_teaser1_image,tx_sgnews_teaser2_image';

			foreach (
				[
					\SGalinski\SgNews\Utility\BackendNewsUtility::CATEGORY_DOKTYPE => [
						'icon' => 'EXT:sg_news/Resources/Public/Images/Category.png',
						'locallangIndex' => 'pageType.category'
					],
					\SGalinski\SgNews\Utility\BackendNewsUtility::NEWS_DOKTYPE => [
						'icon' => 'EXT:sg_news/Resources/Public/Images/News.png',
						'locallangIndex' => 'pageType.news'
					]
				] as $doktype => $configuration) {
				// also add the new doktype to the page language overlays type selector (so that translations can inherit the same type)
				$GLOBALS['TCA'][$table]['columns']['doktype']['config']['items'][] = [
					$localLangBackendPath . $configuration['locallangIndex'],
					$doktype,
					$configuration['icon']
				];
			}

			$GLOBALS['TCA'][$table]['types'][\SGalinski\SgNews\Utility\BackendNewsUtility::NEWS_DOKTYPE] = [
				'showitem' => '--palette--;LLL:EXT:cms/locallang_tca.xlf:' . $pagesTable . '.palettes.standard;standard,
					subtitle;' . $localLangDbPath . $pagesTable . '.subtitle.inPalette,
					description, tx_realurl_pathsegment, author, tx_sgnews_location,
				--div--;' . $localLangDbPath . $pagesTable . '.tabs.images,
					tx_sgnews_teaser2_image, tx_sgnews_teaser1_image,
				--div--;LLL:EXT:frontend/Resources/Private/Language/locallang_tca.xlf:' . $pagesTable . '.tabs.metadata,
					--palette--;LLL:EXT:frontend/Resources/Private/Language/locallang_tca.xlf:' . $pagesTable . '.palettes.abstract;abstract,
					tx_projectbase_seo_titletag,tx_projectbase_seo_canonicaltag,
				--div--;LLL:EXT:core/Resources/Private/Language/Form/locallang_tabs.xlf:language,
					sys_language_uid,
				--div--;LLL:EXT:core/Resources/Private/Language/Form/locallang_tabs.xlf:access,
					--palette--;LLL:EXT:cms/locallang_tca.xlf:' . $pagesTable . '.palettes.visibility;hiddenonly,
					--palette--;LLL:EXT:cms/locallang_tca.xlf:' . $pagesTable . '.palettes.access;access'
			];

			$GLOBALS['TCA'][$table]['types'][\SGalinski\SgNews\Utility\BackendNewsUtility::CATEGORY_DOKTYPE] = [
				'showitem' => '--palette--;LLL:EXT:cms/locallang_tca.xlf:' . $pagesTable . '.palettes.standard;standard,
					title, tx_realurl_pathsegment,
				--div--;' . $localLangDbPath . $table . '.tabs.images,
					tx_sgnews_teaser2_image, tx_sgnews_teaser1_image,
				--div--;LLL:EXT:frontend/Resources/Private/Language/locallang_tca.xlf:' . $pagesTable . '.tabs.metadata,
					--palette--;LLL:EXT:frontend/Resources/Private/Language/locallang_tca.xlf:' . $pagesTable . '.palettes.abstract;abstract,
					tx_projectbase_seo_titletag,tx_projectbase_seo_canonicaltag, description,
				--div--;LLL:EXT:core/Resources/Private/Language/Form/locallang_tabs.xlf:language,
					sys_language_uid,
				--div--;LLL:EXT:core/Resources/Private/Language/Form/locallang_tabs.xlf:access,
					--palette--;LLL:EXT:cms/locallang_tca.xlf:' . $pagesTable . '.palettes.visibility;hiddenonly,
					--palette--;LLL:EXT:cms/locallang_tca.xlf:' . $pagesTable . '.palettes.access;access'
			];

			\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTCAcolumns(
				$table, [
					'tx_sgnews_teaser1_image' => [
						'exclude' => TRUE,
						'label' => $localLangDbPath . $pagesTable . '.tx_sgnews_teaser1_image',
						'config' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig(
							'tx_sgnews_teaser1_image',
							[
								'maxitems' => 9999,
								'foreign_types' => [
									'0' => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_TEXT => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_IMAGE => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_AUDIO => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_VIDEO => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_APPLICATION => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									]
								],
								'appearance' => [
									'showPossibleLocalizationRecords' => TRUE,
									'showRemovedLocalizationRecords' => TRUE,
									'showSynchronizationLink' => TRUE,
									'showAllLocalizationLink' => TRUE,
								],
							],
							$GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext']
						),
					],
					'tx_sgnews_teaser2_image' => [
						'exclude' => TRUE,
						'label' => $localLangDbPath . $pagesTable . '.tx_sgnews_teaser2_image',
						'config' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig(
							'tx_sgnews_teaser2_image',
							[
								'maxitems' => 9999,
								'foreign_types' => [
									'0' => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_TEXT => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_IMAGE => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_AUDIO => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_VIDEO => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									],
									\TYPO3\CMS\Core\Resource\File::FILETYPE_APPLICATION => [
										'showitem' => '
										--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
										--palette--;;filePalette'
									]
								],
								'appearance' => [
									'showPossibleLocalizationRecords' => TRUE,
									'showRemovedLocalizationRecords' => TRUE,
									'showSynchronizationLink' => TRUE,
									'showAllLocalizationLink' => TRUE,
								],
							],
							$GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext']
						),
					],
					'tx_sgnews_location' => [
						'exclude' => TRUE,
						'label' => $localLangDbPath . $pagesTable . '.tx_sgnews_location',
						'config' => [
							'type' => 'input',
							'size' => 20,
							'eval' => 'trim'
						]
					]
				]
			);

		}, 'sg_news', 'pages_language_overlay'
	);
}
